bash_validator
==============

bash_validator is based on shellcheck. This project help you to keep you shell script clean, it use
shellcheck which is shell script analysis tool.


Requirement (optional step)
---------------------------

Install will try to solve this (package managers `apt-get`, `pkg` or `yum` are supported)

```bash
sudo apt update && sudo apt -y install shellcheck
```

More detail about `shellcheck` installation: <https://github.com/koalaman/shellcheck#user-content-installing>


Installation
------------

Clone the repository or download a version, then run:

```bash
sudo bash bash_validator-install.sh
```

To remove the applications, use:

```bash
sudo bash /usr/local/share/bash_validator/bash_validator-remove.sh
```

### Installation options

You can use following command to get help:

```bash
bash ./bash_validator-install.sh --help
```

| Option                               | Description |
|--------------------------------------|-------------|
| -h, --help                           | Display help message and exit. |
| -S, --skip-update                    | Skip package manager update |
| -P PMEXE, --package-manager PMEXE    | Force package manager binary name |
| -G, --install-shellcheck-from-github | Install shellcheck from github (othewise use package manager) |


Usage
-----

Just launch `bash_validator` from any folder, `bash_validator` will check
any shell script it can find.

```bash
# cd your_source_root_folder

bash_validator
```

If you want to restrict analysis to `*.sh` files only.

```bash
bash_validator --sh-only [-v|-vv|--verbose]
```


Options
-------

| Option              | Description                   |
|---------------------|-------------------------------|
| `--help`            | Display help message and exit |
| `--sh-only`         | Limit analysis to files with `.sh` extension. |
| `-v` or `--verbose` | Verbose output |
| `-vv`               | More verbose   |
| `-d DIR` or `--root-directory DIR` | Allow to specify root directory for analysis. If not set use current path. |


Local configuration
-------------------

if file `.bash_validator-ignore` exists in current directory (could be overwrited by `--root-directory`), content is take in account instead of global configuration.

You can use `bash_validator-add-to-ignore` to manage this file

```bash
bash_validator-add-to-ignore --local path/to/file-to-ignore
```

If you need to ignore some files using absolute path, you can set configuration at user level:

```bash
bash_validator-add-to-ignore --user path/to/file-to-ignore
```


Related documentation
---------------------

* [Let's do Bash right!](https://github.com/progrium/bashstyle): bashstyle documentation,
* [Beginner Mistakes](http://wiki.bash-hackers.org/scripting/newbie_traps),
* [The Bash Hackers Wiki](http://wiki.bash-hackers.org/).
